# 目录
[概述](#概述)  
[数据结构实验](#数据该结构实验)  
[参考文献](#参考文献)  

# 概述
本教程可以用于C语言数据结构的实验课程。  
请读者`务必先阅读` [DS Lab使用手册](app-manual.md) 和 [学生使用手册](https://www.codecode.net/engintime/codecode/studentsmanual/blob/master/readme.md)，然后再按照下面的内容完成实验。  

# 数据结构实验

数据结构实验提供了28个实验题目，主要包含28个实验模板，涵盖了线性表、链表、二叉树、图、查找、排序等重要的知识点。在每个实验题目下面包含了相应的实验模板，每个模板可以有针对性的对知识点进行练习，通过使用这些模板根据题目的要求完成实验，就可以对数据结构中的绝大部分的知识进行强化。通过完成这些实验，可以提高编程水平，对以后从事相关方面的研发有很大的帮助作用。  

## 实验题目清单
[实验1 实验环境的使用](#实验1-实验环境的使用)  
[实验2 线性表的顺序表示及插入操作](#实验2-线性表的顺序表示及插入操作)  
[实验3 线性表的顺序表示及删除操作](#实验3-线性表的顺序表示及删除操作)  
[实验4 单链表的插入操作](#实验4-单链表的插入操作)  
[实验5 单链表的删除操作](#实验5-单链表的删除操作)  
[实验6 双向循环链表的插入操作](#实验6-双向循环链表的插入操作)  
[实验7 双向循环链表的删除操作](#实验7-双向循环链表的删除操作)  
[实验8 字符串的顺序表示及插入操作](#实验8-字符串的顺序表示及插入操作)  
[实验9 二叉树的先序遍历操作](#实验9-二叉树的先序遍历操作)  
[实验10 二叉树的中序遍历操作](#实验10-二叉树的中序遍历操作)  
[实验11 二叉树的后序遍历操作](#实验11-二叉树的后序遍历操作)  
[实验12 线索二叉树](#实验12-线索二叉树)  
[实验13 赫夫曼树的构造](#实验13-赫夫曼树的构造)  
[实验14 一般树的遍历](#实验14-一般树的遍历)  
[实验15 图的深度优先搜索](#实验15-图的深度优先搜索)  
[实验16 图的广度优先搜索](#实验16-图的广度优先搜索)  
[实验17 拓扑排序](#实验17-拓扑排序)  
[实验18 关键路径](#实验18-关键路径)  
[实验19 最短路径（迪杰斯特拉算法）](#实验19-最短路径迪杰斯特拉算法)  
[实验20 最短路径（弗洛伊德算法）](#实验20-最短路径弗洛伊德算法)  
[实验21 折半查找](#实验21-折半查找)  
[实验22 二叉排序树的构造](#实验22-二叉排序树的构造)  
[实验23 创建哈希表（线性探测再散列）](#实验23-创建哈希表线性探测再散列)  
[实验24 创建哈希表（二次探测再散列）](#实验24-创建哈希表二次探测再散列)  
[实验25 创建哈希表（伪随机探测再散列）](#实验25-创建哈希表伪随机探测再散列)  
[实验26 冒泡排序](#实验26-冒泡排序)  
[实验27 快速排序](#实验27-快速排序)  
[实验28 堆排序](#实验28-堆排序)

## 实验1 实验环境的使用
建议学时：1学时

**`实验目的`**

- 熟悉数据结构集成实验环境DS Lab的基本使用方法。   
- 掌握线性表的顺序表示。
- 实现线性表的插入操作。


**`实验任务`**  

如果是第一次使用DS Lab完成实验，请先阅读[DS Lab 使用手册](./app-manual.md)和[学生使用手册](https://www.codecode.net/engintime/codecode/studentsmanual/blob/master/readme.md)，
这样读者可以学习DS Lab的使用方法，后面的实验按照DS Lab使用手册的实验步骤就可以顺利完成。  

请读者在本平台的[课程](https://www.codecode.net/dashboard/courses)中，通过领取教师在数据结构课程中布置的任务来新建一个项目，然后按照项目中readme.md文件中的要求完成实验。

>
教师用户应使用实验模板Lab001创建用于完成本次实验的任务，[domain relative url](engintime/ds-lab/Project-Template/Lab001.git)访问实验模板Lab001
>

## 实验2 线性表的顺序表示及插入操作  
建议学时：1学时

**`实验目的`**  
- 掌握线性表的顺序表示。
- 实现线性表的插入操作。

**`实验任务`**  

请读者在本平台的[课程](https://www.codecode.net/dashboard/courses)中，通过领取教师在数据结构课程中布置的任务来新建一个项目，然后按照项目中readme.md文件中的要求完成实验。  

>
教师用户应使用实验模板Lab002创建用于完成本次实验的任务，[domain relative url](engintime/ds-lab/Project-Template/Lab002.git)访问实验模板Lab002     
>

## 实验3 线性表的顺序表示及删除操作  
建议学时：1学时

**`实验目的`**  
- 掌握线性表的顺序表示。
- 实现线性表的删除操作。


**`实验任务`**

请读者在本平台的[课程](https://www.codecode.net/dashboard/courses)中，通过领取教师在数据结构课程中布置的任务来新建一个项目，然后按照项目中readme.md文件中的要求完成实验。   

>
教师用户应使用实验模板Lab003创建用于完成本次实验的任务，[domain relative url](engintime/ds-lab/Project-Template/Lab003.git)访问实验模板Lab003      
>

## 实验4 单链表的插入操作  
建议学时：1学时

**`实验目的`**  
- 掌握线性表的链式表示。
- 实现单链表的插入操作。

**`实验任务`**

请读者在本平台的[课程](https://www.codecode.net/dashboard/courses)中，通过领取教师在数据结构课程中布置的任务来新建一个项目，然后按照项目中readme.md文件中的要求完成实验。  

>
教师用户应使用实验模板Lab004创建用于完成本次实验的任务，[domain relative url](engintime/ds-lab/Project-Template/Lab004.git)访问实验模板Lab004    
>

## 实验5 单链表的删除操作  
建议学时：1学时

**`实验目的`**  
- 掌握线性表的链式表示。
- 实现单链表的删除操作。



**`实验任务`**

请读者在本平台的[课程](https://www.codecode.net/dashboard/courses)中，通过领取教师在数据结构课程中布置的任务来新建一个项目，然后按照项目中readme.md文件中的要求完成实验。   

>
教师用户应使用实验模板Lab005创建用于完成本次实验的任务，[domain relative url](engintime/ds-lab/Project-Template/Lab005.git)访问实验模板Lab005  
>

## 实验6 双向循环链表的插入操作
建议学时：1学时

**`实验目的`**  
- 掌握线性表的链式表示。
- 实现双向循环链表的插入操作。


**`实验任务`**

请读者在本平台的[课程](https://www.codecode.net/dashboard/courses)中，通过领取教师在数据结构课程中布置的任务来新建一个项目，然后按照项目中readme.md文件中的要求完成实验。  

>
教师用户应使用实验模板Lab006创建用于完成本次实验的任务，[domain relative url](engintime/ds-lab/Project-Template/Lab006.git)访问实验模板Lab006  
>

## 实验7 双向循环链表的删除操作
建议学时：1学时

**`实验目的`**  
- 掌握线性表的链式表示。
- 实现双向循环链表的删除操作。


**`实验任务`**

请读者在本平台的[课程](https://www.codecode.net/dashboard/courses)中，通过领取教师在数据结构课程中布置的任务来新建一个项目，然后按照项目中readme.md文件中的要求完成实验。  

>
教师用户应使用实验模板Lab007创建用于完成本次实验的任务，[domain relative url](engintime/ds-lab/Project-Template/Lab007.git)访问实验模板Lab007   
>
 
## 实验8 字符串的顺序表示及插入操作
建议学时：1学时

**`实验目的`**   
- 掌握字符串的顺序表示。
- 实现字符串的插入操作。


**`实验任务`**

请读者在本平台的[课程](https://www.codecode.net/dashboard/courses)中，通过领取教师在数据结构课程中布置的任务来新建一个项目，然后按照项目中readme.md文件中的要求完成实验。    

>
教师用户应使用实验模板Lab008创建用于完成本次实验的任务，[domain relative url](engintime/ds-lab/Project-Template/Lab008.git)访问实验模板Lab008  
>

## 实验9 二叉树的先序遍历操作
建议学时：1学时

**`实验目的`**  
- 掌握二叉树的链式存储结构。
- 实现二叉树的先序遍历操作。


**`实验任务`**

请读者在本平台的[课程](https://www.codecode.net/dashboard/courses)中，通过领取教师在数据结构课程中布置的任务来新建一个项目，然后按照项目中readme.md文件中的要求完成实验。   

>
教师用户应使用实验模板Lab009创建用于完成本次实验的任务，[domain relative url](engintime/ds-lab/Project-Template/Lab009.git)访问实验模板Lab009    
>

## 实验10 二叉树的中序遍历操作
建议学时：1学时

**`实验目的`**  
- 掌握二叉树的链式存储结构。
- 实现二叉树的中序遍历操作。


**`实验任务`**

请读者在本平台的[课程](https://www.codecode.net/dashboard/courses)中，通过领取教师在数据结构课程中布置的任务来新建一个项目，然后按照项目中readme.md文件中的要求完成实验。   

>
教师用户应使用实验模板Lab010创建用于完成本次实验的任务，[domain relative url](engintime/ds-lab/Project-Template/Lab010.git)访问实验模板Lab010    
>

## 实验11 二叉树的后序遍历操作
建议学时：1学时

**`实验目的`**   
- 掌握二叉树的链式存储结构。
- 实现二叉树的后序遍历操作。


**`实验任务`**

请读者在本平台的[课程](https://www.codecode.net/dashboard/courses)中，通过领取教师在数据结构课程中布置的任务来新建一个项目，然后按照项目中readme.md文件中的要求完成实验。   

>
教师用户应使用实验模板Lab011创建用于完成本次实验的任务，[domain relative url](engintime/ds-lab/Project-Template/Lab011.git)访问实验模板Lab011    
>

## 实验12 线索二叉树
建议学时：1学时

**`实验目的`**   
- 掌握线索二叉树的链式存储结构。
- 实现二叉树的中序线索化。


**`实验任务`**

请读者在本平台的[课程](https://www.codecode.net/dashboard/courses)中，通过领取教师在数据结构课程中布置的任务来新建一个项目，然后按照项目中readme.md文件中的要求完成实验。   

>
教师用户应使用实验模板Lab012创建用于完成本次实验的任务，[domain relative url](engintime/ds-lab/Project-Template/Lab012.git)访问实验模板Lab012    
>

## 实验13 赫夫曼树的构造
建议学时：1学时

**`实验目的`**   
- 掌握赫夫曼树的存储结构。
- 实现赫夫曼树的构造过程。


**`实验任务`**

请读者在本平台的[课程](https://www.codecode.net/dashboard/courses)中，通过领取教师在数据结构课程中布置的任务来新建一个项目，然后按照项目中readme.md文件中的要求完成实验。   

>
教师用户应使用实验模板Lab013创建用于完成本次实验的任务，[domain relative url](engintime/ds-lab/Project-Template/Lab013.git)访问实验模板Lab013    
>

## 实验14 一般树的遍历
建议学时：1学时  

**`实验目的`**   
- 掌握一般树的二叉链表表示法。
- 实现一般树的先序遍历算法。


**`实验任务`**

请读者在本平台的[课程](https://www.codecode.net/dashboard/courses)中，通过领取教师在数据结构课程中布置的任务来新建一个项目，然后按照项目中readme.md文件中的要求完成实验。    

>
教师用户应使用实验模板Lab014创建用于完成本次实验的任务，[domain relative url](engintime/ds-lab/Project-Template/Lab014.git)访问实验模板Lab014    
>
   
## 实验15 图的深度优先搜索
建议学时：1学时  

**`实验目的`**    
- 掌握图的邻接表存储结构。
- 实现图的深度优先搜索。


**`实验任务`**

请读者在本平台的[课程](https://www.codecode.net/dashboard/courses)中，通过领取教师在数据结构课程中布置的任务来新建一个项目，然后按照项目中readme.md文件中的要求完成实验。    

>
教师用户应使用实验模板Lab015创建用于完成本次实验的任务，[domain relative url](engintime/ds-lab/Project-Template/Lab015.git)访问实验模板Lab015   
>

## 实验16 图的广度优先搜索
建议学时：1学时  

**`实验目的`**   
- 掌握图的邻接表存储结构。
- 实现图的广度优先搜索。


**`实验任务`**

请读者在本平台的[课程](https://www.codecode.net/dashboard/courses)中，通过领取教师在数据结构课程中布置的任务来新建一个项目，然后按照项目中readme.md文件中的要求完成实验。    

>
教师用户应使用实验模板Lab016创建用于完成本次实验的任务，[domain relative url](engintime/ds-lab/Project-Template/Lab016.git)访问实验模板Lab016   
>

## 实验17 拓扑排序 
建议学时：1学时  

**`实验目的`**   
- 掌握图的邻接表存储结构。
- 实现图的拓扑排序操作。


**`实验任务`**

请读者在本平台的[课程](https://www.codecode.net/dashboard/courses)中，通过领取教师在数据结构课程中布置的任务来新建一个项目，然后按照项目中readme.md文件中的要求完成实验。    

>
教师用户应使用实验模板Lab017创建用于完成本次实验的任务，[domain relative url](engintime/ds-lab/Project-Template/Lab017.git)访问实验模板Lab017   
>

## 实验18 关键路径 
建议学时：1学时  

**`实验目的`**   
- 掌握图的邻接表存储结构。
- 实现图的关键路径查找操作。


**`实验任务`**

请读者在本平台的[课程](https://www.codecode.net/dashboard/courses)中，通过领取教师在数据结构课程中布置的任务来新建一个项目，然后按照项目中readme.md文件中的要求完成实验。    

>
教师用户应使用实验模板Lab018创建用于完成本次实验的任务，[domain relative url](engintime/ds-lab/Project-Template/Lab018.git)访问实验模板Lab018   
>

## 实验19 最短路径（迪杰斯特拉算法）
建议学时：1学时  

**`实验目的`**   
- 掌握图的邻接矩阵存储结构。
- 实现图的最短路径查找操作（迪杰斯特拉算法）。


**`实验任务`**

请读者在本平台的[课程](https://www.codecode.net/dashboard/courses)中，通过领取教师在数据结构课程中布置的任务来新建一个项目，然后按照项目中readme.md文件中的要求完成实验。    

>
教师用户应使用实验模板Lab019创建用于完成本次实验的任务，[domain relative url](engintime/ds-lab/Project-Template/Lab019.git)访问实验模板Lab019   
>

## 实验20 最短路径（弗洛伊德算法） 
建议学时：1学时  

**`实验目的`**   
- 掌握图的邻接矩阵存储结构。
- 实现图的最短路径查找操作（弗洛伊德算法）。


**`实验任务`**

请读者在本平台的[课程](https://www.codecode.net/dashboard/courses)中，通过领取教师在数据结构课程中布置的任务来新建一个项目，然后按照项目中readme.md文件中的要求完成实验。    

>
教师用户应使用实验模板Lab020创建用于完成本次实验的任务，[domain relative url](engintime/ds-lab/Project-Template/Lab020.git)访问实验模板Lab020   
>

## 实验21 折半查找
建议学时：1学时  

**`实验目的`**   
- 实现折半查找算法。

**`实验任务`**

请读者在本平台的[课程](https://www.codecode.net/dashboard/courses)中，通过领取教师在数据结构课程中布置的任务来新建一个项目，然后按照项目中readme.md文件中的要求完成实验。    

>
教师用户应使用实验模板Lab021创建用于完成本次实验的任务，[domain relative url](engintime/ds-lab/Project-Template/Lab021.git)访问实验模板Lab021   
>

## 实验22 二叉排序树的构造
建议学时：1学时  

**`实验目的`**   
- 掌握二叉排序树的链式存储结构。
- 实现二叉排序树的构造。


**`实验任务`**

请读者在本平台的[课程](https://www.codecode.net/dashboard/courses)中，通过领取教师在数据结构课程中布置的任务来新建一个项目，然后按照项目中readme.md文件中的要求完成实验。    

>
教师用户应使用实验模板Lab022创建用于完成本次实验的任务，[domain relative url](engintime/ds-lab/Project-Template/Lab022.git)访问实验模板Lab022   
>

## 实验23 创建哈希表（线性探测再散列）
建议学时：1学时  

**`实验目的`**   
- 实现哈希表的创建。
- 利用线性探测再散列处理冲突。


**`实验任务`**

请读者在本平台的[课程](https://www.codecode.net/dashboard/courses)中，通过领取教师在数据结构课程中布置的任务来新建一个项目，然后按照项目中readme.md文件中的要求完成实验。    

>
教师用户应使用实验模板Lab023创建用于完成本次实验的任务，[domain relative url](engintime/ds-lab/Project-Template/Lab023.git)访问实验模板Lab023   
>

## 实验24 创建哈希表（二次探测再散列）
建议学时：1学时  

**`实验目的`**   
- 实现哈希表的创建。
- 利用二次探测再散列处理冲突。


**`实验任务`**

请读者在本平台的[课程](https://www.codecode.net/dashboard/courses)中，通过领取教师在数据结构课程中布置的任务来新建一个项目，然后按照项目中readme.md文件中的要求完成实验。    

>
教师用户应使用实验模板Lab024创建用于完成本次实验的任务，[domain relative url](engintime/ds-lab/Project-Template/Lab024.git)访问实验模板Lab024   
>

## 实验25 创建哈希表（伪随机探测再散列）
建议学时：1学时  

**`实验目的`**   
- 实现哈希表的创建。
- 利用伪随机探测再散列处理冲突。


**`实验任务`**

请读者在本平台的[课程](https://www.codecode.net/dashboard/courses)中，通过领取教师在数据结构课程中布置的任务来新建一个项目，然后按照项目中readme.md文件中的要求完成实验。    

>
教师用户应使用实验模板Lab025创建用于完成本次实验的任务，[domain relative url](engintime/ds-lab/Project-Template/Lab025.git)访问实验模板Lab025   
>

## 实验26 冒泡排序
建议学时：1学时  

**`实验目的`**   
- 实现冒泡排序算法。

**`实验任务`**

请读者在本平台的[课程](https://www.codecode.net/dashboard/courses)中，通过领取教师在数据结构课程中布置的任务来新建一个项目，然后按照项目中readme.md文件中的要求完成实验。    

>
教师用户应使用实验模板Lab026创建用于完成本次实验的任务，[domain relative url](engintime/ds-lab/Project-Template/Lab026.git)访问实验模板Lab026   
>

## 实验27 快速排序
建议学时：1学时  

**`实验目的`**   
- 实现快速排序算法。

**`实验任务`**

请读者在本平台的[课程](https://www.codecode.net/dashboard/courses)中，通过领取教师在数据结构课程中布置的任务来新建一个项目，然后按照项目中readme.md文件中的要求完成实验。    

>
教师用户应使用实验模板Lab027创建用于完成本次实验的任务，[domain relative url](engintime/ds-lab/Project-Template/Lab027.git)访问实验模板Lab027   
>

## 实验28 堆排序
建议学时：1学时  

**`实验目的`**   
- 实现堆排序算法。

**`实验任务`**

请读者在本平台的[课程](https://www.codecode.net/dashboard/courses)中，通过领取教师在数据结构课程中布置的任务来新建一个项目，然后按照项目中readme.md文件中的要求完成实验。    

>
教师用户应使用实验模板Lab028创建用于完成本次实验的任务，[domain relative url](engintime/ds-lab/Project-Template/Lab028.git)访问实验模板Lab028   
>

# 参考文献

[1]   张乃孝编著．算法与数据结构——C语言描述（第3版）．北京：高等教育出版社，2011   
[2]   严蔚敏编著．数据结构（C语言版）．北京：清华大学出版社，2007   
[3]   唐宁九，游洪跃等编著．数据结构与算法教程（C++版）实验和课程设计．北京：清华大学出版社，2012
 